"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _reference = require("./reference");

var _app = _interopRequireDefault(require("firebase/app"));

require("firebase/database");

require("firebase/auth");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var baseConfig = {
  userProfilePath: "/users/",
  userAdminProp: "isAdmin",
  localStorageTokenName: "aorFirebaseClientToken",
  handleAuthStateChange: function () {
    var _handleAuthStateChange = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee(auth, config) {
      var user, snapshot, profile;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (!auth) {
                _context.next = 11;
                break;
              }

              user = auth.user;
              _context.next = 4;
              return _app.default.database().ref(config.userProfilePath + user.uid).once("value");

            case 4:
              snapshot = _context.sent;
              profile = snapshot.val();

              if (!(profile && profile[config.userAdminProp])) {
                _context.next = 10;
                break;
              }

              return _context.abrupt("return", user);

            case 10:
              _app.default.auth().signOut();

            case 11:
              localStorage.removeItem(config.localStorageTokenName); //      throw new Error('sign_in_error');

              return _context.abrupt("return", false);

            case 13:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    return function handleAuthStateChange(_x, _x2) {
      return _handleAuthStateChange.apply(this, arguments);
    };
  }()
};

var _default = function _default() {
  var config = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  config = _objectSpread({}, baseConfig, config);

  if (_app.default.apps.length === 0) {
    _app.default.initializeApp(config.firebaseConfig);

    _app.default.auth().setPersistence(config.firebasePersistence);
  }

  if (_app.default.auth().currentUser) {
    _app.default.auth().currentUser.reload();
  }

  return (
    /*#__PURE__*/
    function () {
      var _ref = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee2(type, params) {
        var username, password, auth;
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                if (!(type === _reference.AUTH_LOGOUT)) {
                  _context2.next = 3;
                  break;
                }

                config.handleAuthStateChange(null, config).catch(function () {});
                return _context2.abrupt("return", _app.default.auth().signOut());

              case 3:
                if (!(type === _reference.AUTH_CHECK)) {
                  _context2.next = 10;
                  break;
                }

                _context2.next = 6;
                return new Promise(function (r) {
                  return _app.default.auth().onAuthStateChanged(r);
                });

              case 6:
                if (!_app.default.auth().currentUser) {
                  _context2.next = 9;
                  break;
                }

                _context2.next = 9;
                return _app.default.auth().currentUser.reload();

              case 9:
                return _context2.abrupt("return", !!_app.default.auth().currentUser);

              case 10:
                if (!(type === _reference.AUTH_LOGIN)) {
                  _context2.next = 16;
                  break;
                }

                username = params.username, password = params.password;
                _context2.next = 14;
                return _app.default.auth().signInWithEmailAndPassword(username, password);

              case 14:
                auth = _context2.sent;
                return _context2.abrupt("return", config.handleAuthStateChange(auth, config));

              case 16:
                return _context2.abrupt("return", false);

              case 17:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      return function (_x3, _x4) {
        return _ref.apply(this, arguments);
      };
    }()
  );
};

exports.default = _default;