"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _app = _interopRequireDefault(require("firebase/app"));

require("firebase/database");

var _sortBy = _interopRequireDefault(require("sort-by"));

var _adminOnRest = require("admin-on-rest");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var getMany =
/*#__PURE__*/
function () {
  var _ref = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee(params, resourceData, type) {
    var idList, filter, pagination, sort, ids, data, total, i, l, id, value, values, filters, page, perPage, startIndex, endIndex;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            idList = params.ids || false;
            filter = params.filter || false;
            pagination = params.pagination || {
              page: 1,
              perPage: 10
            };
            sort = params.sort || {
              field: "id",
              order: "DESC"
            };
            ids = [];
            data = [];
            total = 0;

            if (!(type === _adminOnRest.GET_MANY)) {
              _context.next = 12;
              break;
            }

            for (i = 0, l = idList.length; i < l; i++) {
              id = idList[i];
              value = resourceData[id];

              if (value) {
                data.push(value);
                ids.push(id);
              }
            }

            total = data.length;
            _context.next = 25;
            break;

          case 12:
            if (!(type === _adminOnRest.GET_LIST)) {
              _context.next = 24;
              break;
            }

            values = Object.values(resourceData);

            if (filter) {
              filters = Object.keys(filter);
              values = values.filter(function (value) {
                var valid = true;
                filters.map(function (filterProp) {
                  var filterValue = filter[filterProp];

                  if (typeof value[filterProp] === "string" && filterValue && valid) {
                    valid = value[filterProp].indexOf(filterValue) >= 0;
                  }

                  if (typeof value[filterProp] === "number" && !isNaN(filterValue) && valid) {
                    valid = value[filterProp] === parseFloat(filterValue);
                  }
                });
                return valid;
              });
            }

            values.sort((0, _sortBy.default)((sort.order === "ASC" ? "-" : "") + sort.field));
            total = values.length;
            page = pagination.page, perPage = pagination.perPage;
            startIndex = (page - 1) * perPage;
            endIndex = page * perPage;
            data = values.slice(startIndex, endIndex);
            ids = data.map(function (_ref2) {
              var id = _ref2.id;
              return id;
            });
            _context.next = 25;
            break;

          case 24:
            throw new Error("Error processing request");

          case 25:
            return _context.abrupt("return", {
              data: data,
              ids: ids,
              total: total
            });

          case 26:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function getMany(_x, _x2, _x3) {
    return _ref.apply(this, arguments);
  };
}();

var getOne = function getOne(params, resourceData) {
  if (params.id && resourceData[params.id]) {
    return {
      data: resourceData[params.id]
    };
  } else {
    throw new Error("Key not found");
  }
};

var getId = function getId(params, resourceData, type, resourcePath) {
  var id = params.data.id || params.id;

  if (!id) {
    id = _app.default.database().ref().child(resourcePath).push().key;
  }

  if (!id) {
    throw new Error("ID is required");
  }

  if (resourceData && resourceData[id] && type === _adminOnRest.CREATE) {
    throw new Error("ID already in use");
  }

  return id;
};

var save =
/*#__PURE__*/
function () {
  var _ref3 = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee2(params, resourceName, type, resourcePath, preSave, uploadResults, timestampFields) {
    var data, previous;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            data = params.data;
            previous = params.previousData || {};

            if (uploadResults) {
              uploadResults.map(function (uploadResult) {
                return uploadResult ? Object.assign(data, uploadResult) : false;
              });
            }

            if (type === _adminOnRest.CREATE) {
              data[timestampFields.createdAt] = Date.now();
            }

            data = Object.assign({}, previous, _defineProperty({}, timestampFields.updatedAt, Date.now()), data);

            if (!data.id) {
              data.id = params.__id;
            }

            _context2.next = 8;
            return _app.default.database().ref("".concat(resourcePath, "/").concat(data.id)).update(preSave(data));

          case 8:
            return _context2.abrupt("return", {
              data: data
            });

          case 9:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function save(_x4, _x5, _x6, _x7, _x8, _x9, _x10) {
    return _ref3.apply(this, arguments);
  };
}();

var del =
/*#__PURE__*/
function () {
  var _ref4 = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee3(params, resourcePath, uploadFields) {
    var id;
    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            id = params.id;

            if (uploadFields.length) {
              uploadFields.map(function (fieldName) {
                return _app.default.storage().ref().child("".concat(resourcePath, "/").concat(id, "/").concat(fieldName)).delete();
              });
            }

            _context3.next = 4;
            return _app.default.database().ref("".concat(resourcePath, "/").concat(id)).remove();

          case 4:
            return _context3.abrupt("return", {
              data: id
            });

          case 5:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3, this);
  }));

  return function del(_x11, _x12, _x13) {
    return _ref4.apply(this, arguments);
  };
}();

var getImageSize = function getImageSize(file) {
  return new Promise(function (resolve) {
    // eslint-disable-next-line no-undef
    var img = document.createElement("img");

    img.onload = function () {
      resolve({
        width: this.width,
        height: this.height
      });
    };

    img.src = file.src;
  });
};

var upload =
/*#__PURE__*/
function () {
  var _ref5 = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee4(fieldName, params, resourceName, resourcePath) {
    var submitedData, id, file, rawFile, result, ref, snapshot, imageSize;
    return regeneratorRuntime.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            submitedData = params.data;
            id = params.__id;
            file = submitedData[fieldName] && submitedData[fieldName][0];
            rawFile = file.rawFile;
            result = {};

            if (!(file && rawFile && rawFile.name)) {
              _context4.next = 27;
              break;
            }

            ref = _app.default.storage().ref().child("".concat(resourcePath, "/").concat(id, "/").concat(fieldName));
            _context4.next = 9;
            return ref.put(rawFile);

          case 9:
            snapshot = _context4.sent;
            result[fieldName] = [{}];
            result[fieldName][0].uploadedAt = Date.now();
            result[fieldName][0].src = snapshot.downloadURL.split("?").shift() + "?alt=media";
            result[fieldName][0].type = rawFile.type;

            if (!(rawFile.type.indexOf("image/") === 0)) {
              _context4.next = 26;
              break;
            }

            _context4.prev = 15;
            _context4.next = 18;
            return getImageSize(file);

          case 18:
            imageSize = _context4.sent;
            result[fieldName][0].width = imageSize.width;
            result[fieldName][0].height = imageSize.height;
            _context4.next = 26;
            break;

          case 23:
            _context4.prev = 23;
            _context4.t0 = _context4["catch"](15);
            // eslint-disable-next-line no-console
            console.error("Failed to get image dimensions");

          case 26:
            return _context4.abrupt("return", result);

          case 27:
            return _context4.abrupt("return", false);

          case 28:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4, this, [[15, 23]]);
  }));

  return function upload(_x14, _x15, _x16, _x17) {
    return _ref5.apply(this, arguments);
  };
}();

var _default = {
  upload: upload,
  save: save,
  del: del,
  getId: getId,
  getOne: getOne,
  getMany: getMany,
  preSave: function preSave(data) {
    return data;
  },
  postRead: function postRead(data) {
    return data;
  }
};
exports.default = _default;